Index: CMT/HEAD/mgr/requirements
===================================================================
--- CMT/HEAD/mgr/requirements	(revision 586)
+++ CMT/HEAD/mgr/requirements	(revision 588)
@@ -588,6 +588,11 @@
 make_fragment constituents_trailer
 
+make_fragment packages_header
+make_fragment package
+make_fragment packages_trailer
+
 make_fragment dependencies
 make_fragment dependencies_and_triggers
+make_fragment dependency
 
 make_fragment readme_header
Index: CMT/HEAD/source/cmt.h
===================================================================
--- CMT/HEAD/source/cmt.h	(revision 586)
+++ CMT/HEAD/source/cmt.h	(revision 588)
@@ -111,4 +111,5 @@
   static void do_build_constituents_makefile (const ArgParser& ap);
   static void do_build_constituents_config (const ArgParser& ap);
+  static void do_build_broadcast_config (const ArgParser& ap);
   static void do_build_dependencies (const ArgParser& ap,
                                      int argc,
Index: CMT/HEAD/source/cmt_cmtpath_pattern.cxx
===================================================================
--- CMT/HEAD/source/cmt_cmtpath_pattern.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_cmtpath_pattern.cxx	(revision 588)
@@ -278,2 +278,7 @@
 }
 
+bool CmtPathPattern::is_constant () const
+{
+  return ((line.find ("<path>") == cmt_string::npos) &&
+	  (line.find ("<project>") == cmt_string::npos));
+}
Index: CMT/HEAD/source/cmt_cmtpath_pattern.h
===================================================================
--- CMT/HEAD/source/cmt_cmtpath_pattern.h	(revision 586)
+++ CMT/HEAD/source/cmt_cmtpath_pattern.h	(revision 588)
@@ -35,4 +35,5 @@
   void apply () const;
   void expand (cmt_string& line, const cmt_string& path, const cmt_string& project) const;
+  bool is_constant () const;
 
   cmt_string line;
Index: CMT/HEAD/source/cmt_commands.cxx
===================================================================
--- CMT/HEAD/source/cmt_commands.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_commands.cxx	(revision 588)
@@ -694,15 +694,68 @@
 	    }
 	}
+      else if (arg == "broadcast_config")
+	{
+	  cmt.m_action = action_build_broadcast_config;
+
+	  if (cmt.m_scope_filtering_mode == default_filtering_mode)
+	    {
+	      cmt.m_scope_filtering_mode = reach_private_uses;
+	    }
+
+	  while (argc > 0)
+	    {
+	      cmt_string arg(argv[0]);
+	      if (arg.substr (0, 5) == "-out=")
+		{
+		  fill_one_argument ();
+		}
+	      else
+		{
+		  help_action = action_help;
+		  CmtError::set (CmtError::syntax_error, arg + ": wrong argument");
+		  break;
+		}
+	    }
+	}
       else if (arg == "dependencies")
 	{
 	  if (argc > 0)
 	    {
-	      fill_arguments ();
+	      //	      fill_arguments ();
+	      while (argc > 0)
+		{
+		  cmt_string arg(argv[0]);
+		  if (arg.substr (0, 3) == "-f=")
+		    {
+		      shift ();
+		      extra_file = arg.substr (3);
+		    }
+		  else if (arg.substr (0, 3) == "-e=")
+		    {
+		      shift ();
+		      extra_line = arg.substr (3);
+		    }
+		  else if (arg == "-with_cmt")
+		    {
+		      shift ();
+		      cmt.m_use_cmt = true;
+		    }
+		  else if (arg == "-without_cmt")
+		    {
+		      shift ();
+		      cmt.m_use_cmt = false;
+		    }
+		  else
+		    {
+		      fill_one_argument ();
+		    }
+		}  
 	      cmt.m_action = action_build_dependencies;
 	    }
 	  else
 	    {
-	      CmtMessage::error ("syntax: arguments missing");
+	      //CmtMessage::error ("syntax: arguments missing");
 	      //	      if (!cmt.m_quiet) cerr << "#CMT> syntax error : arguments missing " << endl;
+	      CmtError::set (CmtError::syntax_error, "arguments missing");
 	      help_action = action_help;
 	      cmt.m_action = action_build_dependencies;
@@ -2309,5 +2362,5 @@
 void CommandHelp::show (ActionType action)
 {
-  //cerr << "CommandHelp::show> action = " << action << endl;
+  //  cerr << "CommandHelp::show> action = " << action << endl;
 
   static HelpTexts& help_texts = get_help_texts ();
@@ -2375,5 +2428,6 @@
   help_texts.add () =  "build constituents_makefile [-out=<path>] : generate constituents Makefile";
   help_texts.add () =  "build constituents_config [-out=<path>] [-with_cmt] [-without_cmt] : generate constituents Makefile, tag specific Makefile, and setup definitions file, also input requirements file for constituent(s) without associated tag";
-  help_texts.add () =  "build dependencies      : generate dependencies";
+  help_texts.add () =  "build broadcast_config [-out=<path>] : generate broadcast Makefile, and broadcast specific macros Makefile";
+  help_texts.add () =  "build dependencies [-out=<path>] [-all_sources] [-no_stamps] [-I<directory>]... [-start_all FILE... -end_all] NAME FILE... : generate dependencies for FILEs of constituent NAME";
   help_texts.add () =  "build library_links     : build symbolic links towards all imported libraries";
   help_texts.add () =  "build make_setup        : build a compiled version of setup scripts";
@@ -2477,4 +2531,5 @@
   help.add (action_build_constituents_makefile, help_texts[action_build_constituents_makefile]);
   help.add (action_build_constituents_config, help_texts[action_build_constituents_config]);
+  help.add (action_build_broadcast_config, help_texts[action_build_broadcast_config]);
   help.add (action_build_dependencies, help_texts[action_build_dependencies]);
   help.add (action_build_library_links, help_texts[action_build_library_links]);
Index: CMT/HEAD/source/cmt_constituent.cxx
===================================================================
--- CMT/HEAD/source/cmt_constituent.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_constituent.cxx	(revision 588)
@@ -47,4 +47,5 @@
       if (symbol.type != Symbol::SymbolAction) continue;
 
+      /*
       if (symbol.value_lists.size () < 1) continue;
 
@@ -55,4 +56,6 @@
 	  add_for_action (symbol.name);
 	}
+      */
+      add_for_action (symbol);
     }
 
@@ -368,10 +371,10 @@
       //cerr << "Constituent " << name << " Analyzing module " << ew << endl;
 
-      if (ew.substr (0, 13) == "action_value=")
-	{
-          it.set (ew);
-	}
-      else
-	{
+//       if (ew.substr (0, 13) == "action_value=")
+// 	{
+//           it.set (ew);
+// 	}
+//       else
+// 	{
 	  CmtSystem::split (ew, " \t", ws);
 
@@ -383,5 +386,5 @@
 	      it.set (w);
 	    }
-	}
+// 	}
     }
 
@@ -417,18 +420,35 @@
 
 //----------------------------------------------------------
-Constituent* Constituent::add_for_action (const cmt_string& name)
-{
-  Constituent* constituent;
-
-  constituent = add (Document, name, "cmt_action_runner");
+Constituent* Constituent::add_for_action (const Symbol& symbol)
+//Constituent* Constituent::add_for_action (const cmt_string& name)
+{
+  Constituent* constituent (0);
+  if (symbol.value_lists.size () < 1) return constituent;
+
+  const Tag* tag = Tag::find ("target_" + symbol.name);
+  const bool target_tag_used
+    (Tag::check_tag_used (tag) || Symbol::check_tag_used (tag));
+
+  cmt_string value = symbol.build_macro_value ();
+  if ( "" == value && !target_tag_used) return constituent;
+
+  constituent = add (Document, symbol.name, "cmt_action_runner");
 
   constituent->group = Group::add ("cmt_actions");
-  constituent->has_target_tag = true;
+
+  // Do NOT assign target_<name> by default
+  // but only if this tag is used somewhere
+  if (target_tag_used)
+    constituent->has_target_tag = true;
 
   cmt_string& p1 = constituent->parameters.add ();
   p1 = "action_value=";
-  p1 += "$(";
-  p1 += name;
-  p1 += ")";
+  Symbol::expand (value);
+  // quote since split will later be applied
+  // - in parse
+  p1 += CmtSystem::quote (value, " \t");
+//   p1 += "$(";
+//   p1 += symbol.name;
+//   p1 += ")";
 
   return (constituent);
@@ -549,5 +569,6 @@
   if (!simulation)
     {
-      Generator::build_constituent_makefile (*this);
+      bool dependencies (false);
+      Generator::build_constituent_makefile (*this, dependencies);
     }
 }
Index: CMT/HEAD/source/cmt_constituent.h
===================================================================
--- CMT/HEAD/source/cmt_constituent.h	(revision 586)
+++ CMT/HEAD/source/cmt_constituent.h	(revision 588)
@@ -23,5 +23,6 @@
                            const cmt_string& name,
                            const cmt_string& generator);
-  static Constituent* add_for_action (const cmt_string& name);
+  static Constituent* add_for_action (const Symbol& action);
+  //static Constituent* add_for_action (const cmt_string& name);
   static void show (const cmt_string& name);
   static void parse_all ();
Index: CMT/HEAD/source/cmt_deps_builder.cxx
===================================================================
--- CMT/HEAD/source/cmt_deps_builder.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_deps_builder.cxx	(revision 588)
@@ -11,4 +11,5 @@
 #include "cmt_symbol.h"
 #include "cmt_log.h"
+#include "cmt_error.h"
 
 //
@@ -92,4 +93,5 @@
         {
           cmt_string stamp_file;
+	  log << "|header_file_action> header " << header_file_path << " against stamp " << stamp_file << log_endl;
           if (header_filters[i].use_stamp (header_file_path, stamp_file))
             {
@@ -113,5 +115,9 @@
 ///////////////////////////////////////////////////////////////////////////////////////////////////////
   cmt_string text;
-  text.read (header_file_path);
+  if (!text.read (header_file_path))
+    {
+      CmtError::set (CmtError::file_access_error, header_file_path);
+      return;
+    }
   char* ptr = &text[0];
   cmt_string new_dir;
@@ -725,5 +731,9 @@
     {
       cmt_string text;
-      text.read (full_name);
+      if (!text.read (full_name))
+	{
+	  CmtError::set (CmtError::file_access_error, full_name);
+	  return -2;
+	}
       char* ptr = &text[0];
       cmt_string new_dir;
@@ -746,4 +756,5 @@
     {
       log << "CMT> build_deps3" << log_endl;
+      CmtError::set (CmtError::path_not_found, name);
     }
   return path_index;
@@ -811,4 +822,14 @@
 
 //--------------------------------------------------------------------------
+DepsBuilder::DepsBuilder ()
+{ }
+
+//--------------------------------------------------------------------------
+DepsBuilder::~DepsBuilder ()
+{
+  clear ();
+}
+
+//--------------------------------------------------------------------------
 void DepsBuilder::clear ()
 {
@@ -820,4 +841,6 @@
     }
   m_header_filters.clear ();
+  m_deps.clear ();
+  m_all_deps.clear ();
 }
 
@@ -829,15 +852,17 @@
       return;
     }
+
+  cmt_string p = path;
   if (path[path.size () - 1] == CmtSystem::file_separator ())
     {
-      cmt_string p = path;
-      p.erase (path.size () - 1);
-      m_include_paths.push_back (p);
-    }
-  else
-    {
-      m_include_paths.push_back (path);
-    }
-
+      p = path.substr(0, path.size () - 1);
+    }
+  for (int k = m_include_paths.size () - 1; k >= 0; k--)
+    if (m_include_paths[k] == p)
+      {
+	return;
+      }
+  
+  m_include_paths.push_back (p);
   m_substitutions.push_back (substitution);
 }
@@ -919,9 +944,11 @@
 
 //--------------------------------------------------------------------------
-CmtSystem::cmt_string_vector& DepsBuilder::run (const cmt_string& file_name)
+CmtSystem::cmt_string_vector& DepsBuilder::run (const cmt_string& file_name,
+						const cmt_string& constituent_name)
 {
   Log;
 
   log << "Starting deps builder on " << file_name << log_endl;
+  CmtMessage::info ("calculating dependencies for " + file_name);
 
   m_deps.clear ();
@@ -974,7 +1001,23 @@
       // missing)
       //
-      preprocessor += " ";
       macro = Symbol::find ("includes");
-      preprocessor += macro->resolve_macro_value ();
+      if (0 != macro)
+	{
+	  preprocessor += " ";
+	  preprocessor += macro->resolve_macro_value ();
+	}
+      macro = Symbol::find ("app_" + constituent_name + "_cppflags");
+      if (0 != macro)
+	{
+	  preprocessor += " ";
+	  preprocessor += macro->resolve_macro_value ();
+	}
+      macro = Symbol::find ("lib_" + constituent_name + "_cppflags");
+      if (0 != macro)
+	{
+	  preprocessor += " ";
+	  preprocessor += macro->resolve_macro_value ();
+	}
+      
       preprocessor += " ";
       preprocessor += file_name;
@@ -982,5 +1025,10 @@
       cmt_string output;
       
-      CmtSystem::execute (preprocessor, output);
+      int status = CmtSystem::execute (preprocessor, output);
+      if (0 != status)
+	{
+	  CmtError::set (CmtError::execution_failed, preprocessor, status);
+	  return m_deps;
+	}
 
       //
@@ -1041,5 +1089,5 @@
 
 //--------------------------------------------------------------------------
-void DepsBuilder::add_header_filter (const Use* use, const cmt_regexp* filter, const cmt_string& stamp)
+void DepsBuilder::add_header_filter (const Use* use, cmt_regexp* filter, const cmt_string& stamp)
 {
   add_header_filter (HeaderFilter (use, filter, stamp));
Index: CMT/HEAD/source/cmt_deps_builder.h
===================================================================
--- CMT/HEAD/source/cmt_deps_builder.h	(revision 586)
+++ CMT/HEAD/source/cmt_deps_builder.h	(revision 588)
@@ -23,5 +23,5 @@
       : m_use (0), m_filter (0) { }
 
-    HeaderFilter (const Use* use, const cmt_regexp* filter, const cmt_string& stamp)
+    HeaderFilter (const Use* use, cmt_regexp* filter, const cmt_string& stamp)
       : m_use (use), m_filter (filter), m_stamp (stamp) { }
 
@@ -38,5 +38,9 @@
       {
         m_use = 0;
-        if (m_filter) delete m_filter;
+        if (m_filter) 
+	  {
+	    m_filter->clear ();
+	    delete m_filter;
+	  }
         m_filter = 0;
         m_stamp = cmt_string (); 
@@ -46,5 +50,5 @@
 
     const Use* m_use;
-    const cmt_regexp* m_filter;
+    cmt_regexp* m_filter;
     cmt_string m_stamp;
   };
@@ -55,20 +59,20 @@
   void add (const cmt_string& path, const cmt_string& substitution);
   void add_includes (const Use& use);
-  void add_header_filter (const Use* use, const cmt_regexp* filter, const cmt_string& stamp);
+  void add_header_filter (const Use* use, cmt_regexp* filter, const cmt_string& stamp);
   void add_header_filter (const HeaderFilter& hf);
-  CmtSystem::cmt_string_vector& run (const cmt_string& file_name);
+  CmtSystem::cmt_string_vector& run (const cmt_string& file_name,
+				     const cmt_string& constituent_name);
 
-  DepsBuilder ()
-    { }
+  DepsBuilder ();
+  ~DepsBuilder ();
 
 private:
 
-  DepsBuilder (const DepsBuilder&)
-    { }
+  DepsBuilder (const DepsBuilder&);
+  DepsBuilder& operator = (const DepsBuilder&);
 
   CmtSystem::cmt_string_vector m_include_paths;
   CmtSystem::cmt_string_vector m_substitutions;
   HeaderFilters m_header_filters;
-
   CmtSystem::cmt_string_vector m_deps;
   CmtSystem::cmt_string_vector m_all_deps;
Index: CMT/HEAD/source/cmt_generator.cxx
===================================================================
--- CMT/HEAD/source/cmt_generator.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_generator.cxx	(revision 588)
@@ -19,4 +19,6 @@
 #include "cmt_log.h"
 #include "cmt_error.h"
+
+#include "cmt_install_area.h"
 
 //------------------------------------------------------------------------
@@ -143,4 +145,8 @@
 
   m_source_files.clear ();
+  m_bin = "";
+  m_output_file_name = "";
+  m_output_file = 0;
+  m_constituent = 0;
 
   Language::setup_all_fragments ();
@@ -350,5 +356,5 @@
       if (Cmt::get_debug ())
         {
-          cout << "CmtGenerator::fill_names_ outputs>" << endl;
+          cout << "CmtGenerator::fill_names_outputs>" << endl;
 	  cout << "name=" << name << " LINE=" << m_LINE << endl;
 	  cout << "output=" << output << " OBJS=" << m_OBJS << endl;
@@ -399,4 +405,5 @@
 }
 
+/*
 //--------------------------------------------------
 void CmtGenerator::prepare_use_context ()
@@ -476,5 +483,5 @@
     }
 }
-
+*/
 //--------------------------------------------------
 void CmtGenerator::filter_path (cmt_string& text)
@@ -700,4 +707,5 @@
 static MakeSetupGenerator MakeSetupContext;
 static ConstituentsMakefileGenerator ConstituentsMakefileContext;
+static PackagesMakefileGenerator PackagesMakefileContext;
 static DependencyGenerator DependencyContext;
 
@@ -813,5 +821,417 @@
 
 //--------------------------------------------------
+int Generator::build_library_links_infile (const cmt_string& outdir)
+{
+#ifndef WIN32
+  cmt_string file ("library_links.in");
+  if (outdir != "")
+    {
+      if (outdir [outdir.size () - 1] != CmtSystem::file_separator ())
+	file = outdir + CmtSystem::file_separator () + file;
+      else
+	file = outdir + file;
+    }
+
+  bool wrote (false);
+  ostringstream ls;
+
+  Use::UsePtrVector& Uses = Use::get_ordered_uses ();
+  Use& current_use = Use::current ();
+  Use::UsePtrVector uses (Uses);
+  uses.push_back (&Use::current ());
+
+  cmt_string shlibsuffix;
+  {
+    Symbol* macro = Symbol::find ("shlibsuffix");
+    if (macro == 0)
+      {
+	CmtError::set(CmtError::configuration_error, "shlibsuffix undefined");
+	return -1;
+      }
+    shlibsuffix = macro->build_macro_value ();
+    Symbol::expand (shlibsuffix);
+  }
+
+  for (int i = 0; i < uses.size (); i++)
+    {
+      Use* use = uses[i];
+
+      if (use == 0) continue;
+      if (use->discarded) continue;
+      if (use->m_hidden) continue;
+
+      if (use->get_package_name () == "CMT") continue;
+      if (!use->located ()) continue;
+      //use->remove_library_links (cmtinstallarea, tag, shlibsuffix, symunlinkcmd);
+      cmt_string s (use->get_package_name ());
+      s += "_libraries";
+      const Symbol* libraries_macro = Symbol::find (s);
+      if (libraries_macro == 0) continue;
+      cmt_string libraries = libraries_macro->build_macro_value ();
+      Symbol::expand (libraries);
+      static CmtSystem::cmt_string_vector values;
+      
+      CmtSystem::split (libraries, " \t", values);
+      
+      for (int j = 0; j < values.size (); j++)
+	{
+	  const cmt_string& library = values[j];
+	  
+	  static cmt_string libname;
+	  static cmt_string name;
+	  
+	  // Is it a simple name or a complete path?
+	  
+	  libname = library;
+	  Symbol::expand (libname);
+	  if (0 == libname.size ()) continue;
+	  
+	  CmtSystem::cmt_string_vector paths;
+	  use->absolute_library_path (libname,
+				      shlibsuffix, 
+				      paths);
+	  for (int k = 0; k < paths.size (); k++)
+	    {
+	      cmt_string path (paths[k]);
+	      Symbol::expand (path);
+	      if (0 == path.size ()) continue;
+	      if (wrote) ls << " ";
+	      else wrote = true;
+	      ls << CmtSystem::quote (path, " \t");
+	    }
+	}
+    }
+  ostringstream os;
+  if (wrote)
+    {
+      os << "macro ";
+      os << current_use.get_package_name () + "_libraries ";
+      os << CmtSystem::quote (ls.str ().c_str (), " \t");
+      os << "\n";
+
+      os << "macro shlibsuffix ";
+      os << CmtSystem::quote (shlibsuffix, " \t");
+      os << "\n";
+
+      cmt_string symlinkcmd;
+      {
+	Symbol* macro = Symbol::find ("library_install_command");
+	if (macro != 0)
+	  {
+	    symlinkcmd = macro->build_macro_value ();
+	    Symbol::expand (symlinkcmd);
+	  }
+      }
+      os << "macro library_install_command ";
+      os << CmtSystem::quote (symlinkcmd, " \t");
+      os << "\n";
+
+      cmt_string symunlinkcmd;
+      {
+	Symbol* macro = Symbol::find ("symunlink");
+	if (macro != 0)
+	  {
+	    symunlinkcmd = macro->build_macro_value ();
+	    Symbol::expand (symunlinkcmd);
+	  }
+      }
+      os << "macro symunlink ";
+      os << CmtSystem::quote (symunlinkcmd, " \t");
+      os << "\n";
+
+      if (current_use.get_strategy ("InstallArea"))
+	{
+	  os << "build_strategy with_installarea\n";
+
+	  const CmtInstallAreaMgr& ia_mgr = CmtInstallAreaMgr::instance ();
+	  
+	  cmt_string cmtinstallarea = ia_mgr.get_installarea ();
+	  {
+	    Symbol* symbol = Symbol::find ("CMTINSTALLAREA");
+	    if (symbol != 0)
+	      {
+		cmtinstallarea = symbol->build_macro_value ();
+		Symbol::expand (cmtinstallarea);
+	      }
+	  }
+	  os << "macro CMTINSTALLAREA ";
+	  os << CmtSystem::quote (cmtinstallarea, " \t");
+	  os << "\n";
+
+	  cmt_string tag;
+	  {
+	    Symbol* macro = Symbol::find ("tag");
+	    if (macro != 0)
+	      {
+		tag = macro->build_macro_value ();
+		Symbol::expand (tag);
+	      }
+	  }
+	  os << "macro tag ";
+	  os << CmtSystem::quote (tag, " \t");
+	  os << "\n";
+	}
+      //      cerr << os.str ();
+    }
+
+  // Write input requirements file
+
+  //  static InGenerator InGen (usecmt);
+
+  bool gen (true);
+  //  ostringstream os;
+  ofstream s;
+  //  s.open (file);
+  s.open (file, ios::in);
+  if (s) // file already exists
+    {
+      //      InGen.build (constituent, os);
+      ostringstream osn;
+      osn << s.rdbuf ();
+      if (os.str () == osn.str ())
+	{
+	  //	  cerr << file << " up-to-date" << endl;
+	  gen = false;
+	}
+    }
+  s.clear ();
+  s.close ();
+  s.clear ();
+  if (gen)
+    {
+      s.open (file);
+      if (!s)
+	{
+	  CmtError::set (CmtError::file_access_error, file);
+	  return -1;
+	}
+      s.exceptions (ios::failbit | ios::badbit);
+      try
+	{
+	  //	  if (os.str ().size () != 0)
+	  //	    {
+	      //  cerr << file << " contents already generated" << endl;
+	      s << os.str ();
+	      //	    }
+	      //	  else
+	      //	    {
+	      //	      InGen.build (constituent, s);
+	      //	    }
+	  s.close (); // ios_base::failbit
+	}
+      catch (const ios::failure& e)
+	{
+	  CmtSystem::close_ostream (NULL, file + ": " + cmt_string (e.what ()));
+	  return -1;
+	}
+    }
+
+#endif
+  return 0;
+}
+
+//--------------------------------------------------
+int Generator::build_dependencies_infile (const Constituent* pconstituent,
+					  const cmt_string& outdir,
+					  bool usecmt)
+{
+  cmt_string file ("dependencies");
+  if (0 != pconstituent)
+    file += "_" + pconstituent->name;
+  file += ".in";
+
+  if (outdir != "")
+    {
+      if (outdir [outdir.size () - 1] != CmtSystem::file_separator ())
+	file = outdir + CmtSystem::file_separator () + file;
+      else
+	file = outdir + file;
+    }
+
+  ostringstream os;
+  
+  cmt_string preprocessor;
+  Symbol* macro = Symbol::find ("preprocessor_command");
+  if (macro != 0)
+    {
+      preprocessor = macro->resolve_macro_value ();
+    }
+
+  if (preprocessor == "")
+    {
+      const Use* current_use = &Use::current ();
+      Use::UsePtrVector uses (Use::get_ordered_uses ());
+      uses.push_back (&Use::current ());
+      
+      if (current_use->include_path == "none")
+	os << "include_path none\n";
+
+      for (int i = uses.size () - 1; i >= 0; i--)
+	{
+	  const Use* use = uses[i];
+	  if (use->discarded) continue;
+	  if (use->m_hidden) continue;
+	  if (!use->located ()) continue;
+	  
+	  cmt_string package_name = use->get_package_name ();
+	  if (package_name == "CMT") continue;
+	  
+	  const Symbol* filter_macro = Symbol::find (package_name + "_header_file_filter");
+	  if (filter_macro == 0) continue;
+	  
+	  const Symbol* stamp_macro = Symbol::find (package_name + "_header_file_stamp");
+	  cmt_string stamp;
+	  if (stamp_macro != 0)
+	    {
+	      stamp = stamp_macro->resolve_macro_value ();
+	    }
+	  else
+	    {
+	      use->get_full_path (stamp);
+	      switch (use->style)
+		{
+		case cmt_style:
+		  stamp += CmtSystem::file_separator ();
+		  stamp += "cmt";
+		  break;
+		case mgr_style:
+		  stamp += CmtSystem::file_separator ();
+		  stamp += "mgr";
+		  break;
+		}
+	      stamp += CmtSystem::file_separator ();
+	      stamp += "cmt_header_file.stamp";
+	    }
+	  if (!CmtSystem::test_file (stamp)) continue;
+
+	  os << "macro " + package_name + "_header_file_filter ";
+	  os << CmtSystem::quote (filter_macro->resolve_macro_value (), " \t");
+	  os << "\n";
+	  os << "macro " + package_name + "_header_file_stamp ";
+	  os << CmtSystem::quote (stamp, " \t");
+	  os << "\n";
+	}
+    }
+  else
+    {
+      os << "macro preprocessor_command ";
+      os << CmtSystem::quote (preprocessor, " \t");
+      os << "\n";
+      macro = Symbol::find ("includes");
+      if (0 != macro)
+	{
+	  os << "macro includes ";
+	  os << CmtSystem::quote (macro->resolve_macro_value (), " \t");
+	  os << "\n";
+	}
+      if (0 == pconstituent)
+	{
+	  const Constituent::ConstituentVector& constituents =
+	    Constituent::constituents ();
+	  for (int n = 0; n < constituents.size (); n++)
+	    {
+	      const Constituent& constituent = constituents[n];
+	      if (constituent.has_target_tag) continue;
+	      if (constituent.type == Document) continue;
+	      cmt_string prefix;
+	      switch (constituent.type)
+		{
+		case Application:
+		  prefix = "app_";
+		  break;
+		case Library:
+		  prefix = "lib_";
+		  break;
+		}
+	      cmt_string macro_name (prefix + constituent.name + "_cppflags");
+	      macro = Symbol::find (macro_name);
+	      if (0 != macro)
+		{
+		  os << "macro_append " + macro_name + " ";
+		  os << CmtSystem::quote (macro->resolve_macro_value (), " \t");
+		  os << "\n";
+		}
+	    }
+	}
+      else if (pconstituent->type != Document)
+	{
+	  const Constituent& constituent = *pconstituent;
+	  cmt_string prefix;
+	  switch (constituent.type)
+	    {
+	    case Application:
+	      prefix = "app_";
+	      break;
+	    case Library:
+	      prefix = "lib_";
+	      break;
+	    }
+	  cmt_string macro_name (prefix + constituent.name + "_cppflags");
+	  macro = Symbol::find (macro_name);
+	  if (0 != macro)
+	    {
+	      os << "macro_append " + macro_name + " ";
+	      os << CmtSystem::quote (macro->resolve_macro_value (), " \t");
+	      os << "\n";
+	    }
+	}
+    }
+
+  // Write input requirements file
+
+  bool gen (true);
+  //  ostringstream os;
+  ofstream s;
+  //  s.open (file);
+  s.open (file, ios::in);
+  if (s) // file already exists
+    {
+      //      InGen.build (constituent, os);
+      ostringstream osn;
+      osn << s.rdbuf ();
+      if (os.str () == osn.str ())
+	{
+	  //	  cerr << file << " up-to-date" << endl;
+	  gen = false;
+	}
+    }
+  s.clear ();
+  s.close ();
+  s.clear ();
+  if (gen)
+    {
+      s.open (file);
+      if (!s)
+	{
+	  CmtError::set (CmtError::file_access_error, file);
+	  return -1;
+	}
+      s.exceptions (ios::failbit | ios::badbit);
+      try
+	{
+	  //	  if (os.str ().size () != 0)
+	  //	    {
+	      //  cerr << file << " contents already generated" << endl;
+	      s << os.str ();
+	      //	    }
+	      //	  else
+	      //	    {
+	      //	      InGen.build (constituent, s);
+	      //	    }
+	  s.close (); // ios_base::failbit
+	}
+      catch (const ios::failure& e)
+	{
+	  CmtSystem::close_ostream (NULL, file + ": " + cmt_string (e.what ()));
+	  return -1;
+	}
+    }
+
+  return 0;
+}
+
+//--------------------------------------------------
 int Generator::build_constituent_makefile (const Constituent& constituent,
+					   bool& dependencies,
 					   const cmt_string& file)
 {
@@ -824,8 +1244,8 @@
       //break;
     case Library:
-      LibraryContext.build (package, constituent, file);
+      LibraryContext.build (package, constituent, dependencies, file);
       break;
     case Document:
-      DocumentContext.build (package, constituent, file);
+      DocumentContext.build (package, constituent, dependencies, file);
       break;
     }
@@ -860,5 +1280,9 @@
 
   const Constituent* constituent = Constituent::find (name);
-  if (constituent != 0) build_constituent_makefile (*constituent, file);
+  if (constituent != 0)
+    {
+      bool dependencies (false);
+      build_constituent_makefile (*constituent, dependencies, file);
+    }
 }
 
@@ -867,4 +1291,12 @@
 {
   DefaultMakefileContext.build ();
+}
+
+//--------------------------------------------------
+void Generator::build_packages_makefile (const cmt_string& package,
+					 const cmt_string& file)
+{
+  PackagesMakefileContext.build (package, file);
+  //  UsesMakefileContext.build (package, file);
 }
 
@@ -1213,4 +1645,5 @@
   CmtSystem::cmt_string_vector document;
   document.push_back ("document_header");
+  document.push_back ("dependency");
   m_document.set_names (document);
   m_document.set_uses (usecmt);
Index: CMT/HEAD/source/cmt_generator.h
===================================================================
--- CMT/HEAD/source/cmt_generator.h	(revision 586)
+++ CMT/HEAD/source/cmt_generator.h	(revision 588)
@@ -12,5 +12,4 @@
 #include "cmt_language.h"
 #include "cmt_awk.h"
-#include "cmt_deps_builder.h"
 
 class Packager : public FAwk
@@ -59,5 +58,5 @@
   void fill_outputs ();
 
-  void prepare_use_context ();
+  //  void prepare_use_context ();
 
   void set_full_name (cmt_string& full_name, cmt_string& file);
@@ -96,6 +95,4 @@
   cmt_string m_output_file_name;
   FILE* m_output_file;
-
-  DepsBuilder m_deps_builder;
 
   Constituent* m_constituent;
@@ -215,4 +212,5 @@
     // Build the makefile fragment for one constituent
   static int build_constituent_makefile (const Constituent& constituent,
+					 bool& dependencies,
 					 const cmt_string& file = "");
   static void build_constituent_makefile (const CmtSystem::cmt_string_vector& arguments);
@@ -221,5 +219,15 @@
 				       bool usecmt = true);
 
+  static int build_library_links_infile (const cmt_string& outdir = "");
+
+  static int build_dependencies_infile (const Constituent* constituent,
+					const cmt_string& outdir = "",
+					bool usecmt = true);
+
   static void build_default_makefile ();
+
+    // Build the packages (N)Make file
+  static void build_packages_makefile (const cmt_string& package,
+				       const cmt_string& file = "");
 
     // Build the dependencies for one module
